/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Manuel Meier
 *   Co-authors:
 *      ...
 *
 */

/**
    @file OrxoKartFlag.h
    @brief See .cc File
    @ingroup OrxoKart
*/

#ifndef _OrxoKartFlag_H__
#define _OrxoKartFlag_H__

#include "OrxoKartPrereqs.h"
#include "objects/ObjectsPrereqs.h"
#include "OrxoKartKart.h"

#include "worldentities/StaticEntity.h"

namespace orxonox
{
    class _OrxoKartExport OrxoKartFlag : public StaticEntity
    {
        public:
            OrxoKartFlag(Context* context);
            virtual ~OrxoKartFlag();

            void init(int n, int s);

            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint) override;

            inline bool getCollided() const
                { return this->collided_; }

            inline OrxoKartKart* getObjectofCollision() const
                { return this->kartCollider; }   

            inline void setCollided(bool setValue)
                { this->collided_ = setValue; }


        private:
            Model* model_;
            BoxCollisionShape* cs_;
            bool collided_;
            OrxoKartKart* kartCollider;

    };
}

#endif /* _OrxoKartFlag_H__ */
