/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Cyrill Burgener
 *
 */

/**
    @file OrxoKartKart.cc
    @brief Implementation of the OrxoKartKart control
*/

#include "OrxoKartKart.h"
#include "core/CoreIncludes.h"
#include "core/XMLPort.h"
#include "KartController.h"
namespace orxonox
{
    RegisterClass(OrxoKartKart);

    void ControllableEntity::rotateYaw(const Vector2& value)
    {
        orxout() << "TEST CONTROLlER" << endl;
    }

    OrxoKartKart::OrxoKartKart(Context* context) : SpaceShip(context)
    {
        RegisterObject(OrxoKartKart);
    }

    void OrxoKartKart::moveFrontBack(const Vector2& value)
        { 
            this->steering_.z -= value.x;
            
        }

    void OrxoKartKart::moveRightLeft(const Vector2& value)
        {   
            this->rotateYaw(value);
        }

    void OrxoKartKart::moveUpDown(const Vector2& value)
        { 
            this->steering_.y += value.x; 
            
        }

    void OrxoKartKart::rotateYaw(const Vector2& value)
        {
            
            this->localAngularAcceleration_.setY(this->localAngularAcceleration_.y() - value.x);  
        }

    void OrxoKartKart::XMLPort(Element& xmlelement, XMLPort::Mode mode)
        {
            SUPER(OrxoKartKart, XMLPort, xmlelement, mode);
            
        }


    /**
    @brief
        Removed, does nothing.
    @param value
    */
    void OrxoKartKart::rotatePitch(const Vector2& value) { }

    /**
    @brief
        Removed, does nothing.
    @param value
    */
    void OrxoKartKart::rotateRoll(const Vector2& value) { }


}
