/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Cyrill Burgener
 *   Co-authors:
 *      ...
 *
 */

/**
@file
@brief
    Shared library macros, enums, constants and forward declarations for the OrxoKart module
*/

#ifndef _OrxoKartPrereqs_H__
#define _OrxoKartPrereqs_H__

#include "OrxonoxConfig.h"
#include "OrxonoxPrereqs.h"

//-----------------------------------------------------------------------
// Shared library settings
//-----------------------------------------------------------------------

#if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(HOVER_STATIC_BUILD)
#  ifdef HOVER_SHARED_BUILD
#    define _OrxoKartExport __declspec(dllexport)
#  else
#    if defined( __MINGW32__ )
#      define _OrxoKartExport
#    else
#      define _OrxoKartExport __declspec(dllimport)
#    endif
#  endif
#  define _OrxoKartPrivate
#elif defined (ORXONOX_GCC_VISIBILITY)
#  define _OrxoKartExport  __attribute__ ((visibility("default")))
#  define _OrxoKartPrivate __attribute__ ((visibility("hidden")))
#else
#  define _OrxoKartExport
#  define _OrxoKartPrivate
#endif

//-----------------------------------------------------------------------
// Forward declarations
//-----------------------------------------------------------------------

namespace orxonox
{
    class OrxoKart;
    class OrxoKartFlag;
    class OrxoKartOrigin;
    class OrxoKartKart;
    class OrxoKartTile;
    class TimeHUD;
    class ShroomHUD;
}

#endif /* _HoverPrereqs_H__*/
